﻿namespace UltraGridSummariesAndTotals
{
    using System.Data;
    using System.Windows.Forms;

    using Infragistics.Win;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.ultraGrid1.DataSource = this.CreateDataSet();

            UltraGridColumn descriptionColumn = this.ultraGrid1.DisplayLayout.Bands[0].Columns[0];
            this.ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add(descriptionColumn, false, true);

            this.ultraGrid1.DisplayLayout.Override.GroupByColumnsHidden = DefaultableBoolean.False;
            this.ultraGrid1.DisplayLayout.Override.GroupByRowExpansionStyle = GroupByRowExpansionStyle.Disabled;
            this.ultraGrid1.Rows.ExpandAll(true);

            this.ultraGrid1.CreationFilter = new MyCreationFilter();
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            SummarySettings blahSettings = e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Blah"]);

            blahSettings.SummaryDisplayArea = SummaryDisplayAreas.GroupByRowsFooter | SummaryDisplayAreas.Bottom;
            blahSettings.DisplayFormat = "blah: {0:c}";

            SummarySettings blehSettings = e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Bleh"]);
            blehSettings.SummaryDisplayArea = SummaryDisplayAreas.GroupByRowsFooter | SummaryDisplayAreas.Bottom;
            blehSettings.DisplayFormat = "bleh: {0:c}";
        }

        private void ButtonGroup_Click(object sender, System.EventArgs e)
        {
            UltraGridColumn descriptionColumn = this.ultraGrid1.DisplayLayout.Bands[0].Columns[0];
            UltraGridBand band = this.ultraGrid1.DisplayLayout.Bands[0];

            if (band.SortedColumns.Count > 0)
            {
                band.SortedColumns.Clear();
            }
            else
            {
                band.SortedColumns.Add(descriptionColumn, false, true);
            }
        }

        private object CreateDataSet()
        {
            DataSet dataSet = new DataSet("MyDataSet");
            DataTable dataTable = dataSet.Tables.Add("MyTable");

            dataTable.Columns.Add("Description", typeof(string));
            dataTable.Columns.Add("Blah", typeof(decimal));
            dataTable.Columns.Add("Bleh", typeof(decimal));


            dataTable.Rows.Add(new object[] { "Fish", 500m, 250m });
            dataTable.Rows.Add(new object[] { "Animals", 700m, 0m });

            return dataSet;
        }
    }
}
